<?php

namespace App\Models;

use CodeIgniter\Model;

class MessageModel extends Model
{
    protected $table = 'messages';
    protected $primaryKey = 'id';
    protected $allowedFields = ['request_id', 'user_id', 'message', 'attachment', 'created_at'];
    protected $useTimestamps = true;
    protected $createdField  = 'created_at';
    protected $updatedField  = 'updated_at';

    public function getRequestMessages($requestId)
    {
        return $this->select('messages.*, users.username')
                    ->join('users', 'users.id = messages.user_id')
                    ->where('request_id', $requestId)
                    ->orderBy('created_at', 'ASC')
                    ->findAll();
    }
}