<?= $this->extend('layout/dashboard') ?>

<?= $this->section('content') ?>
<div class="card">
    <div class="card-header">
        <h3 class="card-title">City Management</h3>
    </div>
    <div class="card-body">
        <button type="button" class="btn btn-primary mb-3" data-toggle="modal" data-target="#addCityModal">
            Add New City
        </button>
        <table class="table table-bordered table-striped">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Name</th>
                    <th>Country</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($cities as $city): ?>
                <tr>
                    <td><?= $city['id'] ?></td>
                    <td><?= esc($city['name']) ?></td>
                    <td><?= esc($city['country']) ?></td>
                    <td>
                        <button class="btn btn-danger btn-sm delete-city" data-id="<?= $city['id'] ?>">Delete</button>
                    </td>
                </tr>
                <?php endforeach; ?>
            </tbody>
        </table>
    </div>
</div>

<!-- Add City Modal -->
<div class="modal fade" id="addCityModal" tabindex="-1" role="dialog" aria-labelledby="addCityModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="addCityModalLabel">Add New City</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form id="addCityForm">
                    <div class="form-group">
                        <label for="cityName">City Name</label>
                        <input type="text" class="form-control" id="cityName" name="name" required>
                    </div>
                    <div class="form-group">
                        <label for="cityCountry">Country</label>
                        <input type="text" class="form-control" id="cityCountry" name="country" required>
                    </div>
                </form>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                <button type="button" class="btn btn-primary" id="submitCity">Add City</button>
            </div>
        </div>
    </div>
</div>

<script>
$(document).ready(function() {
    $('#submitCity').click(function() {
        $.ajax({
            url: '<?= base_url('city-management/add') ?>',
            type: 'POST',
            data: $('#addCityForm').serialize(),
            success: function(response) {
                if (response.success) {
                    alert(response.message);
                    location.reload();
                } else {
                    alert('Error: ' + response.message);
                }
            }
        });
    });

    $('.delete-city').click(function() {
        if (confirm('Are you sure you want to delete this city?')) {
            var cityId = $(this).data('id');
            $.ajax({
                url: '<?= base_url('city-management/delete') ?>/' + cityId,
                type: 'POST',
                success: function(response) {
                    if (response.success) {
                        alert(response.message);
                        location.reload();
                    } else {
                        alert('Error: ' + response.message);
                    }
                }
            });
        }
    });
});
</script>
<?= $this->endSection() ?>