<?= $this->extend('layout/dashboard') ?>

<?= $this->section('content') ?>
<div class="card">
    <div class="card-header bg-primary text-white">
        <h3 class="card-title">Edit Request: <?= esc($request['unique_id']) ?></h3>
    </div>
    <div class="card-body">
        <form action="<?= base_url('requests/update/' . $request['id']) ?>" method="post">
            <?= csrf_field() ?>
            
            <div class="form-group">
                <label for="status">Status</label>
                <select name="status" id="status" class="form-control">
                    <option value="new" <?= $request['status'] == 'new' ? 'selected' : '' ?>>New</option>
                    <option value="staff reply" <?= $request['status'] == 'staff reply' ? 'selected' : '' ?>>Staff Reply</option>
                    <option value="waiting for confirmation" <?= $request['status'] == 'waiting for confirmation' ? 'selected' : '' ?>>Waiting for Confirmation</option>
                    <option value="declined" <?= $request['status'] == 'declined' ? 'selected' : '' ?>>Declined</option>
                    <option value="confirmed" <?= $request['status'] == 'confirmed' ? 'selected' : '' ?>>Confirmed</option>
                </select>
            </div>

            <div class="form-group">
    	<label for="arrival_flight">Arrival Flight</label>
    <select name="arrival_flight" id="arrival_flight" class="form-control select2" required>
        <option value="">Select Arrival Flight</option>
        <?php foreach ($flights as $flight): ?>
            <option value="<?= $flight['id'] ?>" <?= ($flight['id'] == $request['arrival_flight_id']) ? 'selected' : '' ?>>
                <?= esc($flight['flight_number']) ?> - <?= esc($flight['departure_city']) ?> to <?= esc($flight['arrival_city']) ?>
            </option>
        <?php endforeach; ?>
    </select>
</div>

<div class="form-group">
    <label for="departure_flight">Departure Flight</label>
    <select name="departure_flight" id="departure_flight" class="form-control select2" required>
        <option value="">Select Departure Flight</option>
        <?php foreach ($flights as $flight): ?>
            <option value="<?= $flight['id'] ?>" <?= ($flight['id'] == $request['departure_flight_id']) ? 'selected' : '' ?>>
                <?= esc($flight['flight_number']) ?> - <?= esc($flight['departure_city']) ?> to <?= esc($flight['arrival_city']) ?>
            </option>
        <?php endforeach; ?>
    </select>
</div>

            <h4>Hotel Information</h4>
            <?php foreach ($request['hotels'] as $index => $hotel): ?>
    <div class="hotel-selection card mb-3">
        <div class="card-body">
            <h5 class="card-title">Hotel <?= $index + 1 ?></h5>
            <input type="hidden" name="hotels[<?= $index ?>][id]" value="<?= $hotel['id'] ?>">
                        
                         <div class="form-group">
                			<label for="hotel_<?= $index ?>">Hotel</label>
                			<select name="hotels[<?= $index ?>][hotel_name]" id="hotel_<?= $index ?>" class="form-control select2" required>
                    		<option value="">Select Hotel</option>
                    		<?php foreach ($hotels as $h): ?>
                        	<option value="<?= $h['id'] ?>" <?= ($h['id'] == $hotel['hotel_id']) ? 'selected' : '' ?>>
                            <?= esc($h['name']) ?>
                        	</option>
                    		<?php endforeach; ?>
                		</select>
           				 </div>

                        
                        <div class="form-group">
                		<label for="room_<?= $index ?>">Room</label>
                		<select name="hotels[<?= $index ?>][room_type]" id="room_<?= $index ?>" class="form-control select2" required>
                    	<option value="">Select Room</option>
                    	<?php foreach ($rooms as $r): ?>
                        	<option value="<?= $r['id'] ?>" <?= ($r['id'] == $hotel['room_id']) ? 'selected' : '' ?>>
                            <?= esc($r['room_type']) ?>
                        	</option>
                    	<?php endforeach; ?>
                		</select>
            			</div>
                        
                        <div class="form-group">
                            <label>Check-in</label>
                            <input type="date" class="form-control" name="hotels[<?= $index ?>][check_in]" value="<?= $hotel['check_in'] ?>">
                        </div>
                        
                        <div class="form-group">
                            <label>Check-out</label>
                            <input type="date" class="form-control" name="hotels[<?= $index ?>][check_out]" value="<?= $hotel['check_out'] ?>">
                        </div>
                        
                        <div class="form-group">
                            <label>Nights</label>
                            <input type="number" class="form-control" name="hotels[<?= $index ?>][nights]" value="<?= $hotel['nights'] ?>">
                        </div>
                        
                        <div class="form-group">
                            <label>Room Quantity</label>
                            <input type="number" class="form-control" name="hotels[<?= $index ?>][room_quantity]" value="<?= $hotel['room_quantity'] ?>">
                        </div>
                        
                        <div class="form-check">
                            <input type="checkbox" class="form-check-input" id="extra_bed_<?= $index ?>" name="hotels[<?= $index ?>][extra_bed]" <?= $hotel['extra_bed'] ? 'checked' : '' ?>>
                            <label class="form-check-label" for="extra_bed_<?= $index ?>">Extra Bed</label>
                        </div>
                        
                        <div class="form-check">
                            <input type="checkbox" class="form-check-input" id="cwb_<?= $index ?>" name="hotels[<?= $index ?>][cwb]" <?= $hotel['cwb'] ? 'checked' : '' ?>>
                            <label class="form-check-label" for="cwb_<?= $index ?>">CWB</label>
                        </div>
                        
                        <div class="form-check">
                            <input type="checkbox" class="form-check-input" id="cnb_<?= $index ?>" name="hotels[<?= $index ?>][cnb]" <?= $hotel['cnb'] ? 'checked' : '' ?>>
                            <label class="form-check-label" for="cnb_<?= $index ?>">CNB</label>
                        </div>
                        
                        <div class="form-group">
                            <label>Notes</label>
                            <textarea class="form-control" name="hotels[<?= $index ?>][notes]"><?= esc($hotel['notes']) ?></textarea>
                        </div>
                    </div>
                </div>
            <?php endforeach; ?>

            <h4>Passengers</h4>
            <?php foreach ($request['passengers'] as $index => $passenger): ?>
                <div class="card mb-3">
                    <div class="card-body">
                        <input type="hidden" name="passengers[<?= $index ?>][id]" value="<?= $passenger['id'] ?>">
                        
                        <div class="form-group">
                            <label>Name</label>
                            <input type="text" class="form-control" name="passengers[<?= $index ?>][name]" value="<?= esc($passenger['name']) ?>">
                        </div>
                        
                        <div class="form-group">
                            <label>Surname</label>
                            <input type="text" class="form-control" name="passengers[<?= $index ?>][surname]" value="<?= esc($passenger['surname']) ?>">
                        </div>
                        
                        <div class="form-group">
                            <label>Gender</label>
                            <select class="form-control" name="passengers[<?= $index ?>][gender]">
                                <option value="male" <?= $passenger['gender'] == 'male' ? 'selected' : '' ?>>Male</option>
                                <option value="female" <?= $passenger['gender'] == 'female' ? 'selected' : '' ?>>Female</option>
                            </select>
                        </div>
                        
                        <div class="form-check">
                            <input type="checkbox" class="form-check-input" id="is_adult_<?= $index ?>" name="passengers[<?= $index ?>][is_adult]" <?= $passenger['is_adult'] ? 'checked' : '' ?>>
                            <label class="form-check-label" for="is_adult_<?= $index ?>">Adult</label>
                        </div>
                        
                        <div class="form-check">
                            <input type="checkbox" class="form-check-input" id="is_infant_<?= $index ?>" name="passengers[<?= $index ?>][is_infant]" <?= $passenger['is_infant'] ? 'checked' : '' ?>>
                            <label class="form-check-label" for="is_infant_<?= $index ?>">Infant</label>
                        </div>
                    </div>
                </div>
            <?php endforeach; ?>

            <button type="submit" class="btn btn-primary">Update Request</button>
        </form>
    </div>
</div>
<?= $this->endSection() ?>