<?= $this->extend('layout/dashboard') ?>

<?= $this->section('title') ?>Submit New Request<?= $this->endSection() ?>

<?= $this->section('content') ?>
<div class="card">
    <div class="card-header">
        <h3 class="card-title">Submit New Request</h3>
    </div>
    <div class="card-body">
        <form action="<?= base_url('requests/submit') ?>" method="post" id="newRequestForm">
            <!-- Flight Information -->
            <div class="card bg-info">
                <div class="card-header">
                    <h3 class="card-title">Flight Information</h3>
                </div>
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="arrival_flight">Arrival Flight</label>
                                <select class="form-control select2" id="arrival_flight" name="arrival_flight" required>
                                    <option value="">Select Arrival Flight</option>
                                    <?php foreach ($flights as $flight): ?>
                                        <option value="<?= $flight['id'] ?>"><?= $flight['flight_number'] ?> - <?= $flight['departure_city'] ?> to <?= $flight['arrival_city'] ?></option>
                                    <?php endforeach; ?>
                                </select>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="departure_flight">Departure Flight</label>
                                <select class="form-control select2" id="departure_flight" name="departure_flight" required>
                                    <option value="">Select Departure Flight</option>
                                    <?php foreach ($flights as $flight): ?>
                                        <option value="<?= $flight['id'] ?>"><?= $flight['flight_number'] ?> - <?= $flight['departure_city'] ?> to <?= $flight['arrival_city'] ?></option>
                                    <?php endforeach; ?>
                                </select>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
          	
            <!-- Hotel Information -->
            <div class="card bg-success mt-4">
    <div class="card-header">
        <h3 class="card-title">Hotel Information</h3>
    </div>
    <div class="card-body" id="hotelSelections">
        <div class="hotel-selection card bg-light">
            <div class="card-header bg-success">
                <h3 class="card-title">Hotel Information 1</h3>
            </div>
            <div class="card-body">
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
    									<label for="city">City</label>
                                        <select class="form-control select2 city-select" name="city[]" required>
                                            <option value="">Select City</option>
                                            <?php foreach ($cities as $city): ?>
                                                <option value="<?= $city['id'] ?>"><?= $city['name'] ?></option>
                                            <?php endforeach; ?>
                                        </select>
									</div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="hotel">Hotel</label>
                                        <select class="form-control select2 hotel-select" name="hotel[]" required>
                                            <option value="">Select Hotel</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="room">Room</label>
                                        <select class="form-control select2 room-select" name="room[]" required>
                                            <option value="">Select Room</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="nights">Nights</label>
                                        <input type="number" class="form-control" name="nights[]" required min="1">
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="room_quantity">Room Quantity</label>
                                        <input type="number" class="form-control" name="room_quantity[]" required min="1">
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="check_in">Check In</label>
                                        <input type="date" class="form-control" name="check_in[]" required>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="check_out">Check Out</label>
                                        <input type="date" class="form-control" name="check_out[]" required>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <div class="custom-control custom-checkbox">
                                            <input type="checkbox" class="custom-control-input" id="extra_bed_0" name="extra_bed[]">
                                            <label class="custom-control-label" for="extra_bed_0">Extra Bed</label>
                                        </div>
                                        <div class="custom-control custom-checkbox">
                                            <input type="checkbox" class="custom-control-input" id="cwb_0" name="cwb[]">
                                            <label class="custom-control-label" for="cwb_0">CWB</label>
                                        </div>
                                        <div class="custom-control custom-checkbox">
                                            <input type="checkbox" class="custom-control-input" id="cnb_0" name="cnb[]">
                                            <label class="custom-control-label" for="cnb_0">CNB</label>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <label for="notes">Notes</label>
                                <textarea class="form-control" name="notes[]" rows="3"></textarea>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="card-footer">
                    <button type="button" class="btn btn-secondary" id="addHotel">Add Another Hotel</button>
                </div>
            </div>
            
            <hr>
            
            <!-- Passenger Information -->
            <div class="card bg-danger mt-4">
    <div class="card-header">
        <h3 class="card-title">Passenger Information</h3>
    </div>
    <div class="card-body" id="passengerInfo">
        <div class="passenger card bg-light">
            <div class="card-header bg-danger">
                <h3 class="card-title">Passenger Information 1</h3>
            </div>
            <div class="card-body">
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="surname">Surname</label>
                                        <input type="text" class="form-control" name="surname[]" required>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="name">Name</label>
                                        <input type="text" class="form-control" name="name[]" required>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="gender">Gender</label>
                                        <select class="form-control" name="gender[]" required>
                                            <option value="male">Male</option>
                                            <option value="female">Female</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <div class="custom-control custom-checkbox">
                                            <input type="checkbox" class="custom-control-input" id="is_adult_0" name="is_adult[]" checked>
                                            <label class="custom-control-label" for="is_adult_0">ADL</label>
                                        </div>
                                        <div class="custom-control custom-checkbox">
                                            <input type="checkbox" class="custom-control-input" id="is_infant_0" name="is_infant[]">
                                            <label class="custom-control-label" for="is_infant_0">Infant</label>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="card-footer">
                    <button type="button" class="btn btn-secondary" id="addPassenger">Add Another Passenger</button>
                </div>
            </div>

            <div class="mt-4">
                <button type="submit" class="btn btn-primary">Submit Request</button>
            </div>
        </form>
    </div>
</div>

<script>
document.addEventListener('DOMContentLoaded', function() {
    function initializeSelects() {
        $('.select2').select2({
            theme: 'bootstrap4',
            width: '100%'
        });

        $('.flight-select').select2({
            theme: 'bootstrap4',
            width: '100%',
            ajax: {
                url: '<?= base_url('requests/searchFlights') ?>',
                dataType: 'json',
                delay: 250,
                data: function (params) {
                    return {
                        term: params.term
                    };
                },
                processResults: function (data) {
                    return {
                        results: data.map(function(flight) {
                            return {
                                id: flight.id,
                                text: flight.flight_number + ' - ' + flight.departure_city + ' to ' + flight.arrival_city
                            };
                        })
                    };
                },
                cache: true
            },
            minimumInputLength: 2
        });

        $('.city-select').select2({
            theme: 'bootstrap4',
            width: '100%'
        });

        $('.hotel-select').select2({
            theme: 'bootstrap4',
            width: '100%',
            ajax: {
                url: '<?= base_url('requests/searchHotels') ?>',
                dataType: 'json',
                delay: 250,
                data: function (params) {
                    return {
                        term: params.term,
                        city_id: $(this).closest('.hotel-selection').find('.city-select').val()
                    };
                },
                processResults: function (data) {
                    return {
                        results: data.map(function(hotel) {
                            return {
                                id: hotel.id,
                                text: hotel.name
                            };
                        })
                    };
                },
                cache: true
            },
            minimumInputLength: 2
        });

        document.querySelectorAll('.city-select').forEach(function(select) {
            select.addEventListener('change', function() {
                $(this).closest('.hotel-selection').find('.hotel-select').val(null).trigger('change');
            });
        });

        $('.hotel-select').on('select2:select', function (e) {
            var hotelId = e.params.data.id;
            var roomSelect = $(this).closest('.hotel-selection').find('.room-select');
            if (hotelId) {
                fetch('<?= base_url('requests/getRooms') ?>?hotel_id=' + hotelId)
                    .then(response => response.json())
                    .then(data => {
                        roomSelect.empty().append('<option value="">Select Room</option>');
                        data.forEach(function(room) {
                            roomSelect.append(new Option(room.room_type, room.id, false, false));
                        });
                        roomSelect.trigger('change');
                    })
                    .catch(error => console.error('Error:', error));
            } else {
                roomSelect.empty().append('<option value="">Select Room</option>').trigger('change');
            }
        });
        
    }
    

    initializeSelects();

    $('#addHotel').click(function() {
        var hotelCount = $('.hotel-selection').length;
        var newHotel = $('.hotel-selection').first().clone();
        newHotel.find('input').val('');
        newHotel.find('select').val('').removeClass('select2-hidden-accessible').next('.select2-container').remove();
        newHotel.find('textarea').val('');
        newHotel.find('.card-header h3').text('Hotel Information ' + (hotelCount + 1));
        
        // Update IDs for checkboxes
        newHotel.find('input[type="checkbox"]').each(function() {
            var newId = $(this).attr('id').replace('_0', '_' + hotelCount);
            $(this).attr('id', newId).prop('checked', false);
            $(this).next('label').attr('for', newId);
        });
        
        $('#hotelSelections').append(newHotel);
        initializeSelects();
    });

    $('#addPassenger').click(function() {
        var passengerCount = $('.passenger').length;
        var newPassenger = $('.passenger').first().clone();
        newPassenger.find('input:not([type="checkbox"])').val('');
        newPassenger.find('select').val('');
        newPassenger.find('.card-header h3').text('Passenger Information ' + (passengerCount + 1));
        
        // Update IDs for checkboxes
        newPassenger.find('input[type="checkbox"]').each(function() {
            var newId = $(this).attr('id').replace('_0', '_' + passengerCount);
            $(this).attr('id', newId).prop('checked', false);
            $(this).next('label').attr('for', newId);
        });
        
        $('#passengerInfo').append(newPassenger);
        initializeSelects();
    });
});
</script>

<style>
.select2-container--bootstrap4 .select2-selection--single {
    height: calc(2.25rem + 2px) !important;
}
.select2-container--bootstrap4 .select2-selection--single {
    height: calc(2.25rem + 2px) !important;
}

.select2-container--bootstrap4 .select2-selection--single .select2-selection__rendered {
    line-height: calc(2.25rem + 2px) !important;
    padding-left: 0.75rem;
    color: #495057;
}

.select2-container--bootstrap4 .select2-selection--single .select2-selection__arrow {
    height: calc(2.25rem + 2px) !important;
}

.select2-container--bootstrap4 .select2-selection {
    border: 1px solid #ced4da;
}

.select2-container--bootstrap4 .select2-results__option--highlighted[aria-selected] {
    background-color: #007bff;
</style>
<?= $this->endSection() ?>