<?= $this->extend('layout/dashboard') ?>

<?= $this->section('content') ?>

<style>
.timeline {
    list-style-type: none;
    margin: 0;
    padding: 0;
    position: relative;
}
.timeline:before {
    content: '';
    position: absolute;
    top: 0;
    bottom: 0;
    width: 4px;
    background: #ddd;
    left: 31px;
    margin: 0;
    border-radius: 2px;
}
.timeline > li {
    position: relative;
    margin-right: 10px;
    margin-bottom: 15px;
}
.timeline > li:before,
.timeline > li:after {
    content: " ";
    display: table;
}
.timeline > li:after {
    clear: both;
}
.timeline > li > .timeline-item {
    -webkit-box-shadow: 0 1px 1px rgba(0,0,0,0.1);
    box-shadow: 0 1px 1px rgba(0,0,0,0.1);
    border-radius: 3px;
    margin-top: 0;
    background: #fff;
    color: #444;
    margin-left: 60px;
    margin-right: 15px;
    padding: 0;
    position: relative;
}
.timeline > li > .fa {
    width: 30px;
    height: 30px;
    font-size: 15px;
    line-height: 30px;
    position: absolute;
    color: #666;
    background: #d2d6de;
    border-radius: 50%;
    text-align: center;
    left: 18px;
    top: 0;
}
.timeline > .time-label > span {
    font-weight: 600;
    padding: 5px;
    display: inline-block;
    background-color: #fff;
    border-radius: 4px;
}
.timeline-inverse > li > .timeline-item {
    background: #f0f0f0;
    border: 1px solid #ddd;
    -webkit-box-shadow: none;
    box-shadow: none;
}
.timeline-item > .timeline-header {
    margin: 0;
    color: #555;
    border-bottom: 1px solid #f4f4f4;
    padding: 10px;
    font-size: 16px;
    line-height: 1.1;
}
.timeline-item > .timeline-body, 
.timeline-item > .timeline-footer {
    padding: 10px;
}
</style>
<div class="card">
    <div class="card-header bg-primary text-white">
        <h3 class="card-title">Request Details: <?= esc($request['unique_id'] ?? 'N/A') ?></h3>
    </div>
    <div class="card-body">
        <div class="row">
            <div class="col-md-6">
                <div class="card mb-4 bg-light">
                    <div class="card-header bg-info text-white">
                        <h5 class="card-title m-0">Basic Information</h5>
                    </div>
                    <div class="card-body">
                        <p><strong>Submitted By:</strong> <?= esc($request['username'] ?? 'N/A') ?></p>
                        <p><strong>Submission Date:</strong> <?= isset($request['created_at']) ? date('Y-m-d H:i', strtotime($request['created_at'])) : 'N/A' ?></p>
                        <p><strong>Status:</strong> 
    					<?php if (session()->get('role') == 'admin' || session()->get('role') == 'agent'): ?>
        				<select id="status" class="form-control d-inline-block w-auto ml-2">
            			<option value="new" <?= $request['status'] == 'new' ? 'selected' : '' ?>>New</option>
            			<option value="staff reply" <?= $request['status'] == 'staff reply' ? 'selected' : '' ?>>Staff Reply</option>
            			<option value="waiting for confirmation" <?= $request['status'] == 'waiting for confirmation' ? 'selected' : '' ?>>Waiting for Confirmation</option>
            			<option value="declined" <?= $request['status'] == 'declined' ? 'selected' : '' ?>>Declined</option>
            			<option value="confirmed" <?= $request['status'] == 'confirmed' ? 'selected' : '' ?>>Confirmed</option>
        				</select>
    					<?php else: ?>
        				<span class="badge bg-<?= $request['status'] == 'confirmed' ? 'success' : ($request['status'] == 'declined' ? 'danger' : 'warning') ?>">
            			<?= ucfirst($request['status']) ?>
        				</span>
    					<?php endif; ?>
						</p> 
                            <?php if (session()->get('role') == 'admin'): ?>
    							<div class="card mb-4 bg-light">
        						<div class="card-header bg-danger text-white">
            					<h5 class="card-title m-0">Admin Actions</h5>
        						</div>
        						<div class="card-body">
            					<a href="<?= base_url('requests/edit/' . ($request['id'] ?? '')) ?>" class="btn btn-warning mr-2">Edit Request</a>
            					<button type="button" class="btn btn-danger" data-toggle="modal" data-target="#deleteModal">Delete Request</button>
        						</div>
    							</div>
                      			<div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="deleteModalLabel" aria-hidden="true">
        						<div class="modal-dialog" role="document">
           					 	<div class="modal-content">
                				<div class="modal-header">
                    			<h5 class="modal-title" id="deleteModalLabel">Confirm Delete</h5>
                    			<button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        		<span aria-hidden="true">&times;</span>
                    			</button>
                				</div>
                				<div class="modal-body">
                    			Are you sure you want to delete this request? This action cannot be undone.
                				</div>
                				<div class="modal-footer">
                    			<button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    			<a href="<?= base_url('requests/delete/' . ($request['id'] ?? '')) ?>" class="btn btn-danger">Delete</a>
                				</div>
            					</div>
        						</div>
    							</div>
                            
                            <?php endif; ?>
                        <!/p>
                        <p><strong>Arrival Flight:</strong> <?= esc($request['arrival_flight_number'] ?? 'N/A') ?></p>
                        <p><strong>Departure Flight:</strong> <?= esc($request['departure_flight_number'] ?? 'N/A') ?></p>
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                <div class="card mb-4 bg-light">
                    <div class="card-header bg-success text-white">
                        <h5 class="card-title m-0">Passengers</h5>
                    </div>
                    <div class="card-body">
                        <?php if (isset($request['passengers']) && is_array($request['passengers']) && !empty($request['passengers'])): ?>
                            <?php foreach ($request['passengers'] as $index => $passenger): ?>
                                <div class="card mb-2 <?= $index % 2 == 0 ? 'bg-light' : 'bg-white' ?>">
                                    <div class="card-body py-2">
                                        <p class="mb-1"><strong><?= esc($passenger['name'] ?? 'N/A') ?> <?= esc($passenger['surname'] ?? '') ?></strong></p>
                                        <p class="mb-1">Gender: <?= ucfirst($passenger['gender'] ?? 'N/A') ?></p>
                                        <p class="mb-0">Type: <?= isset($passenger['is_adult']) ? ($passenger['is_adult'] ? 'Adult' : (isset($passenger['is_infant']) && $passenger['is_infant'] ? 'Infant' : 'Child')) : 'N/A' ?></p>
                                    </div>
                                </div>
                            <?php endforeach; ?>
                        <?php else: ?>
                            <p>No passenger information available.</p>
                        <?php endif; ?>
                    </div>
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-md-12">
                <div class="card mb-4 bg-light">
                    <div class="card-header bg-warning text-dark">
                        <h5 class="card-title m-0">Hotel Information</h5>
                    </div>
                    <div class="card-body">
                        <?php if (isset($request['hotels']) && is_array($request['hotels']) && !empty($request['hotels'])): ?>
                            <?php foreach ($request['hotels'] as $index => $hotel): ?>
                                <div class="card mb-3 <?= $index % 2 == 0 ? 'bg-light' : 'bg-white' ?>">
                                    <div class="card-body">
                                        <div class="row">
                                            <div class="col-md-6">
                                                <p><strong>Hotel:</strong> <?= esc($hotel['hotel_name'] ?? 'N/A') ?></p>
                                                <p><strong>Room Type:</strong> <?= esc($hotel['room_type'] ?? 'N/A') ?></p>
                                                <p><strong>Check-in:</strong> <?= $hotel['check_in'] ?? 'N/A' ?></p>
                                                <p><strong>Check-out:</strong> <?= $hotel['check_out'] ?? 'N/A' ?></p>
                                            </div>
                                            <div class="col-md-6">
                                                <p><strong>Nights:</strong> <?= $hotel['nights'] ?? 'N/A' ?></p>
                                                <p><strong>Room Quantity:</strong> <?= $hotel['room_quantity'] ?? 'N/A' ?></p>
                                                <p><strong>Extra Bed:</strong> <?= isset($hotel['extra_bed']) ? ($hotel['extra_bed'] ? 'Yes' : 'No') : 'N/A' ?></p>
                                                <p><strong>CWB:</strong> <?= isset($hotel['cwb']) ? ($hotel['cwb'] ? 'Yes' : 'No') : 'N/A' ?></p>
                                                <p><strong>CNB:</strong> <?= isset($hotel['cnb']) ? ($hotel['cnb'] ? 'Yes' : 'No') : 'N/A' ?></p>
                                            </div>
                                        </div>
                                        <p><strong>Notes:</strong> <?= esc($hotel['notes'] ?? 'N/A') ?></p>
                                    </div>
                                </div>
                            <?php endforeach; ?>
                        <?php else: ?>
                            <p>No hotel information available.</p>
                        <?php endif; ?>
                    </div>
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-md-8">
                <div class="card mt-4 bg-light">
                    <div class="card-header bg-info text-white">
                        <h5 class="card-title m-0">Messages</h5>
                    </div>
                    <div class="card-body">
                        <div id="messages">
                            <!-- Messages will be loaded here -->
                        </div>
                        <form id="replyForm" class="mt-3">
                            <div class="form-group">
                                <label for="message">Reply</label>
                                <textarea class="form-control" id="message" name="message" rows="3" required></textarea>
                            </div>
                            <div class="form-group">
                                <label for="attachment">Attachment</label>
                                <input type="file" class="form-control-file" id="attachment" name="attachment">
                            </div>
                            <button type="submit" class="btn btn-primary">Send Reply</button>
                        </form>
                    </div>
                </div>
            </div>
            <div class="col-md-4">
    	<div class="card mt-4 bg-light">
       	 <div class="card-header bg-secondary text-white">
            <h5 class="card-title m-0">Activity Log</h5>
        		</div>
        		<div class="card-body p-0">
            		<ul class="timeline timeline-inverse p-0">
               		 <!-- Activity log will be loaded here -->
            		</ul>
        			</div>
    			</div>
			</div>
        </div>
    </div>
</div>

<script>
$(document).ready(function() {
    loadMessages();
    loadActivityLog();

    $('#replyForm').submit(function(e) {
        e.preventDefault();
        var formData = new FormData(this);
        $.ajax({
            url: '<?= base_url("requests/reply/" . ($request['id'] ?? '')) ?>',
            type: 'POST',
            data: formData,
            processData: false,
            contentType: false,
            success: function(response) {
                console.log('Success response:', response);
                if (response.success) {
                    loadMessages();
                    loadActivityLog();
                    $('#message').val('');
                    $('#attachment').val('');
                } else {
                    console.error('Error in response:', response);
                    alert('Error sending reply: ' + (response.error || 'Unknown error'));
                }
            },
            error: function(xhr, status, error) {
                console.error('AJAX error:', status, error);
                console.error('Response text:', xhr.responseText);
                alert('An error occurred while sending reply. Please try again.');
            }
        });
    });

    $('#status').change(function() {
        $.post('<?= base_url("requests/updateStatus/" . ($request['id'] ?? '')) ?>', {
            status: $(this).val()
        }, function(response) {
            if (response.success) {
                alert('Status updated successfully');
                loadActivityLog();
            } else {
                alert('Error updating status. Please try again.');
            }
        });
    });
});

function loadMessages() {
    $.get('<?= base_url("requests/messages/" . ($request['id'] ?? '')) ?>', function(response) {
        if (response.success) {
            $('#messages').html(response.messages);
        } else {
            console.error('Error loading messages:', response);
            $('#messages').html('<p>Error loading messages. Please refresh the page.</p>');
        }
    }).fail(function(xhr, status, error) {
        console.error('AJAX error when loading messages:', status, error);
        $('#messages').html('<p>Error loading messages. Please refresh the page.</p>');
    });
}

function loadActivityLog() {
    $.get('<?= base_url("requests/activity/" . ($request['id'] ?? '')) ?>', function(response) {
        if (response.success) {
            $('.timeline').html(response.activities);
        } else {
            console.error('Error loading activity log:', response);
            $('.timeline').html('<p>Error loading activity log. Please refresh the page.</p>');
        }
    }).fail(function(xhr, status, error) {
        console.error('AJAX error when loading activity log:', status, error);
        $('.timeline').html('<p>Error loading activity log. Please refresh the page.</p>');
    });
}
</script>
<?= $this->endSection() ?>